

var server_comms = require("./server_comms.js");


var WebSocketServer = require("ws").Server;
var http = require("http");
var express = require("express");
var app = express();
var port = process.env.PORT || 8888;

// ---

app.use(express.static(__dirname + "/"));

var server = http.createServer(app);

server.listen(port);

console.log("http server listening on %d", port)

var wss = new WebSocketServer({
    server: server
});

console.log("websocket server created");

wss.on("connection", function(ws) {

    console.log("websocket connection open");

    ws.on("message", function(received_data) {

        console.log("Received message : " + received_data);

        var received_json;

        received_json = JSON.parse(received_data);

        server_comms.route_msg(received_json, received_data, ws);
    });

    // ---

    ws.on("error", function(event) {

        console.log("ERROR on on on error : " + event);

    });

    // ---

    ws.on("close", function() {

        console.log("websocket connection close");
    });
});

