
var web_audio_player = function() {

var audio_context;

// BUFF_SIZE_AUDIO_RENDERER must be in units of sample frames, i.e., one of:
// 256, 512, 1024, 2048, 4096, 8192, or 16384
var BUFF_SIZE_AUDIO_RENDERER = 16384;

var BUFF_SIZE_TIME_DOMAIN = BUFF_SIZE_AUDIO_RENDERER;

var cushion_factor = 3; // delay start of audio rendering until we have buffered up
// var cushion_factor = 10; // delay start of audio rendering until we have buffered up
var count_num_buffers_received_from_server = 0;

var audio_obj_from_server = {};

var flag_audio_rendering = false;

var did_one_draw = false;

var was_anything_stopped = false;

var microphone_data = {};

var BUFFER_SIZE_STREAM_QUEUE = 2097152; // stens TODO - wrap into a circular queue
var curr_index_stream_buffer = 0;
var server_side_audio_obj;
var streaming_audio_obj = {

    index_stream : 0
};

var final_index;  // suppled by server side ... populated when server senses source exhausted

var streaming_status_ready      = "streaming_status_ready";
var streaming_status_preloading = "streaming_status_preloading";
var streaming_status_active     = "streaming_status_active";
var streaming_status_done       = "streaming_status_done";

var flag_streaming_status = streaming_status_ready; // false when server side stream is done


    // var streaming_node;

  // console.log("TOP web_audio_player ... here is shared_utils ", shared_utils);

// function init_context_audio(given_buffer_size, given_buffer_size_time_domain) {
function init_context_audio() {

    // BUFF_SIZE = given_buffer_size;

    // BUFF_SIZE_TIME_DOMAIN = given_buffer_size_time_domain;

    try {

        // window.AudioContext = window.AudioContext || window.webkitAudioContext;

        window.AudioContext = window.AudioContext ||
            window.webkitAudioContext ||
            window.mozAudioContext ||
            window.oAudioContext ||
            window.msAudioContext;

        audio_context = new AudioContext();
        console.log("cool audio context established");

    } catch (e) {

        alert('Web Audio API is not supported by this browser\n ... get with wit yo');
    }

    // ---

    gain_node = audio_context.createGain(); // Declare gain node
    gain_node.connect(audio_context.destination); // Connect gain node to speakers
};

    // ---


var in_middle_of_playback = false;

function set_false_in_middle_of_playback() {

    in_middle_of_playback = false;

    console.log('just set false to in_middle_of_playback');
}


function cb_stream_is_complete(given_max_index) {

    final_index = given_max_index;

    console.log("SETTING streaming_status_done ... SINCE TOP of cb_stream_is_complete");
    console.log("SETTING streaming_status_done ... SINCE TOP of cb_stream_is_complete");
    console.log("SETTING streaming_status_done ... SINCE TOP of cb_stream_is_complete");

    flag_streaming_status = streaming_status_done;


    console.log("SETTING flag_streaming_status ", flag_streaming_status, 
                " final_index ", final_index);
};

    // ---

function cb_receive_buffer_from_server_to_web_audio_player(audio_obj_from_server) {

    console.log("Cairo ... flag_streaming_status ", flag_streaming_status);

    if (flag_streaming_status === streaming_status_done) {

        console.log("Alexander DONE ... flag_streaming_status ", flag_streaming_status);

        // stens TODO - deallocate web audio player 

        return;
    };

    var curr_index = streaming_audio_obj.index_stream;
    var max_index = streaming_audio_obj.max_index;

// bbb

    if ((! flag_audio_rendering) && curr_index > cushion_factor * BUFF_SIZE_AUDIO_RENDERER) {

        // have we accummulated sufficient safety buffer to launch audio rendering ?

        console.log("BUFF_SIZE_AUDIO_RENDERER ", BUFF_SIZE_AUDIO_RENDERER);

        this.streaming_node = audio_context.createScriptProcessor(BUFF_SIZE_AUDIO_RENDERER, 1, 1);

        setup_onaudioprocess_callback_stream(streaming_node, streaming_audio_obj.buffer,
            streaming_audio_obj.buffer.length, set_false_in_middle_of_playback);

        // followup_fft(streaming_node);
        streaming_node.connect(gain_node);

        flag_streaming_status = streaming_status_active;

        flag_audio_rendering = true;

        // return;
    }



    var local_index_max = audio_obj_from_server.buffer.length;

    console.log(curr_index + " out of " + max_index, " local_index_max " + local_index_max);

    for (var local_index = 0; local_index < local_index_max && curr_index < max_index;) {

        streaming_audio_obj.buffer[curr_index] = audio_obj_from_server.buffer[local_index];
        local_index++;
        curr_index++;
    };

    streaming_audio_obj.index_stream = curr_index;

    console.log("Corinde where U at ... here I am ... cb_stream_audio_buffer_to_web_audio_player");

    // ---

    communication_sockets.socket_client({

        mode : 6, 
        callback : cb_receive_buffer_from_server_to_web_audio_player
    });


};      //      cb_receive_buffer_from_server_to_web_audio_player

// ---

var gain_node;

var source_node;
var fft_analyzer;
var script_processor_audio_file_node;
var script_processor_fft_node;
var script_processor_synth_node;
var script_processor_time_domain_node;

// ---

function setup_onaudioprocess_callback_stream(given_node, render_this_buffer, 
                                            render_size_buffer, done_callback) {

    // 
    var curr_index_synth_buffer = 0; // keep playing until this reaches size of synth buffer

    given_node.onaudioprocess = (function() {

        return function(event) {

            var render_input_buffer;

            console.log("curr_index_synth_buffer ", curr_index_synth_buffer, 
                        " out of render_size_buffer ", render_size_buffer);

            console.log("final_index ", final_index);
            console.log("curr_index_synth_buffer ", curr_index_synth_buffer);
            console.log((flag_streaming_status === streaming_status_done) ? "NOT_DONE" : "YES_DONE_NOW");


            render_input_buffer = event.outputBuffer.getChannelData(0);

            for (var curr_sample = 0; curr_sample < BUFF_SIZE_AUDIO_RENDERER; curr_sample++) {

                render_input_buffer[curr_sample] = render_this_buffer[curr_index_synth_buffer];

                curr_index_synth_buffer++;

                if (curr_index_synth_buffer >= render_size_buffer ||
                    curr_index_synth_buffer >= final_index) {

                    if (given_node) {

                        given_node.disconnect(gain_node);

                        given_node.onaudioprocess = null;

                        given_node = null;

                        console.log('just called disconnect on node attached to this callback ');
                    }

                    // ---

                    done_callback();

                    console.log('render DONE curr_index_synth_buffer ', curr_index_synth_buffer);
                }
            }

            // ---
        };

    }());

    // do_engage(given_node);

} //      setup_onaudioprocess_callback_stream

// ------------------------

// function run_synth() {

//     if (false == allow_synth) {

//         allow_synth = true;

//         // launch_synth();
//         // main_glob();

//         // var this_glob_01 = audio_context.createScriptProcessor(BUFF_SIZE, 1, 1);
//         var this_glob_01 = audio_context.createScriptProcessor(BUFF_SIZE_AUDIO_RENDERER, 1, 1);

//         // init_synth_settings(this_glob_01, 20, 300, BUFF_SIZE, 0.98, 1.01);
//         init_synth_settings(this_glob_01, 20, 300, BUFF_SIZE_AUDIO_RENDERER, 0.98, 1.01);


//         setup_onaudioprocess_callback(this_glob_01);
//         // followup_fft(this_glob_01);

//         this_glob_01.connect(gain_node);


//         was_anything_stopped = false; // reset for any possible subsequent playback

//     } else {

//         console.log('we are already running synth');
//     }
// }

// function stop_synth() {

//     console.log('top of stop_synth ...........');

//     allow_synth = false;

//     was_anything_stopped = true;
// }

// function pause_tune() {

//     console.log("inside pause_tune ");
// }

// ---------------------------------------------------------------------------  //


function render_buffer(given_flavor) {


    var desired_buffer_obj = {};

        // ---


    console.log("stream audio from server to client browser");

    if (flag_streaming_status !== streaming_status_ready) {

        console.error("NOTICE - middle of previous streaming request ... try later");
        return;
    }

    // ---

    streaming_audio_obj.buffer = new Float32Array(BUFFER_SIZE_STREAM_QUEUE);
    streaming_audio_obj.max_index = BUFFER_SIZE_STREAM_QUEUE;


    var comm_msg = {

        mode : 6,
        callback : cb_receive_buffer_from_server_to_web_audio_player,
        media_file : "2500_hz_sine_2_seconds.wav"
    };

    communication_sockets.set_stream_is_complete_cb(cb_stream_is_complete);

    communication_sockets.socket_client(comm_msg);

        // ---

} //      render_buffer

// -----------------------------------------------------------------------  //

return { // to make visible to calling reference frame list function here

    // load the sound

    init_context_audio: init_context_audio,
    render_buffer: render_buffer,
    cb_stream_is_complete : cb_stream_is_complete
};

}(); //  web_audio_player = function()

